/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

// ImageRegistryApplyConfiguration represents an declarative configuration of the ImageRegistry type for use
// with apply.
type ImageRegistryApplyConfiguration struct {
	Reference                *string                                     `json:"reference,omitempty"`
	JMESPath                 *string                                     `json:"jmesPath,omitempty"`
	ImageRegistryCredentials *ImageRegistryCredentialsApplyConfiguration `json:"imageRegistryCredentials,omitempty"`
}

// ImageRegistryApplyConfiguration constructs an declarative configuration of the ImageRegistry type for use with
// apply.
func ImageRegistry() *ImageRegistryApplyConfiguration {
	return &ImageRegistryApplyConfiguration{}
}

// WithReference sets the Reference field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Reference field is set to the value of the last call.
func (b *ImageRegistryApplyConfiguration) WithReference(value string) *ImageRegistryApplyConfiguration {
	b.Reference = &value
	return b
}

// WithJMESPath sets the JMESPath field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the JMESPath field is set to the value of the last call.
func (b *ImageRegistryApplyConfiguration) WithJMESPath(value string) *ImageRegistryApplyConfiguration {
	b.JMESPath = &value
	return b
}

// WithImageRegistryCredentials sets the ImageRegistryCredentials field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ImageRegistryCredentials field is set to the value of the last call.
func (b *ImageRegistryApplyConfiguration) WithImageRegistryCredentials(value *ImageRegistryCredentialsApplyConfiguration) *ImageRegistryApplyConfiguration {
	b.ImageRegistryCredentials = value
	return b
}
